<template>
  <div class="post-list-item-gridview">
    <div class="post-list-item-gridview__user">
      <div class="post-list-item-gridview__avatar">
        <router-link :to="userRoute">
          <UserAvatar :user="post.user" size="md" />
        </router-link>
      </div>
      <div class="post-list-item-gridview__username">
        <router-link :to="userRoute">{{ username }}</router-link>
      </div>
    </div>
    <div class="post-list-item-gridview__body">
      <div class="post-list-item-gridview__bubble">
        <router-link :to="postRoute">&quot;<span v-html="summaryContent" />&quot;</router-link>
      </div>
      <div class="post-list-item-gridview__footer">
        <ul class="vertical">
          <li>
            <router-link :to="topicRoute">{{ post.topic.title }}</router-link>
          </li>
          <li>
            <span data-bs-toggle="tooltip" :title="postCreatedTooltip">{{ postCreatedText }}</span>
          </li>
        </ul>
      </div>
    </div>
  </div>
</template>

<script>
import { UserAvatar } from '../../gallery'
import { usePostListitem } from './post-list-item.js'

export default {
  name: 'PostListItemGridview',
  props: {
    post: { type: Object, required: true },
    alias: { type: String, default: '' },
    view: { type: String, default: 'list' }, // 'list', 'list-summary'
    opUserId: { type: Number, default: 0 },
  },
  components: {
    UserAvatar,
  },
  setup(props) {
    return usePostListitem(props)
  },
}
</script>

<style lang="scss">
@use '../../core/sass/vars';

.post-list-item-gridview {
  display: flex;
  margin-bottom: vars.$spacing;
}

.post-list-item-gridview__user {
  flex: vars.$avatarWidth * 0.5 0 0;
  margin-right: vars.$spacing;
  text-align: center;
}

.post-list-item-gridview__username {
  font-size: vars.$subtextFontSize;
}

.post-list-item-gridview__body {
  flex-grow: 1;
}

.post-list-item-gridview__bubble {
  word-break: break-word;
  position: relative;
  padding: vars.$spacing;
  border-radius: 1rem;
  border-top-left-radius: 0.25rem;
  background-color: vars.$panelColor;
  font-style: italic;

  a {
    color: vars.$textColor;
    &:hover {
      color: vars.$textColor;
    }
  }
}

.dark .post-list-item-gridview__bubble {
  background-color: vars.$darkPanelColor;

  a {
    color: vars.$darkTextColor;
    &:hover {
      color: vars.$darkTextColor;
    }
  }
}

.post-list-item-gridview__footer {
  font-size: vars.$subtextFontSize;
}

$gridGap: vars.$spacing * 2;

// Larger displays
@media only screen and (min-width: vars.$sm) {
  .post-list-item-gridview {
    width: calc((100% - $gridGap) / 2);
  }
}

@media only screen and (min-width: vars.$md) {
  .post-list-item-gridview {
    width: calc((100% - $gridGap * 2) / 3);
  }
}
</style>
